program Wurli;
{ UJA 03.03.95: }
{ Wurlis Abenteuer im verwunschenen Garten, tastaturgesteuert              }
{ 2 Wuermer kriechen ueber'n Screen,                                       }
{ da schauen Duke und UJa hin,                                             }
{ die Tasten, sie klappern,                                                }
{ die Wuermer, sie hasten,                                                 }
{ ja, wo laufen sie denn? Wo laufen sie denn hin?                          }

{     V.0.900 : 1.spielbare Version mit 1 - 2 Wuermern,                    }
{               Speedanfrage, 2 Modi: mit Tasten treiben oder laufenlassen }
{     V.1.000 : 01.11.95: feddich!                                         }

{ Wurmzustand : 0:nicht existent, 1:lebendig, 2:starr, 3:tot, +10: Timer }
{ Wurmrichtung: 0:links, 1:oben, 2:rechts, 3:unten                       }
{ Schikanen:  }
{    0: leere Wiese    Feld 0,3      weiterlaufen             }
{ 1-15: Wurmteile           1,2      Wurm stirbt              }
{   16: Mauer               4        Wurm stoppt              }
{   17: weie Blume         5        Wurmgre=1              }
{   18: blaue Blume         6        +1 Punkt,  +1 Glied      }
{   19: rote Blume          7        +2 Punkte, +2 Glieder    }
{   20: gelbe Blume         8        +5 Punkte, +5 Glieder    }
{   21: Giftflasche         9        Wurm 10 Zyklen gelhmt   }
{   22: Wurmloch            10       Wurm von Loch -> Start   }
{   23: Kaktus              11       Gegner 10 Zyklen gelhmt }
{   24: Wurmeier            12       neuer Wurm               }
{   25: Bmbskes            13       Gegnerwurm - 1           }
{ ----------------------------------------------------------- }

{ screen, image, Anzeigen ok         25.03.95 }
{ Levelroutine, Key-handling         02.01.95 }
{ Events  4 -  9                     20.10.95 }
{ Events 10 - 12                     24.10.95 }
{ Joystick-Routinen                  28.12.97 }

uses crt,graph,dos,drivers,intuit,hiscore,timer,joystick;

const
   xmax=36;   ymax=24;    dx=16;   dy=16;   ox=16;     oy=24;
   ox1=  8;   ox2 =616;   oy0=24;  dy0=24;  maxwurm=5; nwuermer=2;
   wmax=1024;
   imafil='Wurli.ima'; hscfil='Wurli.hsc';  levelfile='WurliL.';
   titel ='oooooooo< *  U J A s   W u r l i   *  Vers.2.00  12/97  *  TP6  *  >oooooooo';

type
   feld=array[0..succ(xmax),0..succ(ymax)] of integer;
   wurm=record
              headptr,tailptr,ri,oldri,zustand,counter,x0,y0,anz:integer;
              x,y           :array[0..wmax] of integer;
              punkte,score  :longint;
           end;
   hoehle=record
             id,nach,x,y:integer;
          end;
   wuermer=array[1..2] of wurm;
   hoehlen=array[0..10] of hoehle;


var
   ima               :array[1..25] of Image;
   igad              :array[1..6]  of Gadget;
   itext1,itext2     :array[1..8] of Intuitext;
   ibord1,ibord2     :array[1..8] of Border;
   hsc               :highscore;
   joy               :joydata;
   joyistda          :boolean;

   ok,ende,neu       :boolean;
   ch                :char;
   f0,f              :feld;
   wurmno            :wuermer;
   hoehleno          :hoehlen;
   time1,time2,ix,iy,nflowers,i,j,level,nplayer,modus:integer;
   ue,antwort                  :string;

{ ---------------------------------------------------------------------- }
procedure delay(t:word);
begin
delay1(t);
end;

procedure bildschirm(var ok:boolean);
const pal:array[0..15,0..2] of integer=
          (( 0, 0, 0),(63,60,53),( 0,38,38),(39,55,55),
           (13,45,42),(43,21,13),(50,37,26),(57,51,35),
           (63, 0, 0),(63,53, 0),( 5,48, 0),(20, 5,55),
           (39, 0, 0),(47,35, 0),(15,28,23),(26,34,37));
var i,j:integer;

begin
initscreen(ok);
if ok then begin
   for i:=0 to 15 do begin
      setpalette(i,i);
      setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   end;
end;
end;

procedure zeichnescreen;
var i,j,k,x,y:integer;
    temp     :string;
begin
   rectfill(0,0,639,479,14);
   setcolor(3); line(1,478,1,1);       line(1,1,638,1);
   setcolor(2); line(638,2,638,478);   line(1,478,638,478);
   rectfill(8,8,631,23,15);
   setcolor(1); line(8,23,8,8);        line(8,8,631,8);
   setcolor(0); line(631,9,631,23);    line(8,23,631,23);
   rectfill(8,456,631,471,15);
   setcolor(1); line(8,471,8,456);     line(8,456,631,456);
   setcolor(0); line(631,457,631,471); line(8,471,631,471);
   setcolor(1); outtextxy(16,12,titel);
   setcolor(0); outtextxy(15,12,titel);
   temp:='* Wurli1: 0000000 * Level: I N T E R N                   * Wurli2: 0000000 *';
   setcolor(1); outtextxy(16,460,temp);
   setcolor(0); outtextxy(15,460,temp);
end;

procedure holeimages(var ok:boolean);
var i:integer;
    f:file;
    size,anz:word;
begin
{$i-}
assign(f,imafil);
reset(f,1);
ok:=ioresult=0;
{$i+}
if ok then begin
   for i:=1 to 25 do begin
      blockread(f,ima[i],sizeof(image),anz);
      with ima[i] do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         blockread(f,p_data^,size,anz);
      end;
   end;
   close(f);
end;
end;


{ ----- wurli1.inc - Feld einlesen ----- }

procedure readlevel(var level:integer; var ue:string;  var flow:integer;
                    var f0:feld;       var h0:hoehlen; var w:wuermer);
const code=' Ww#oO*x+0123456789EBK';
var i,j,k,nh:integer;
    temp    :string;
    f       :text;
    ok      :boolean;

begin
{ Initialisierung: }
   for i:=1 to 10 do h0[i].id:=99;
   for i:=0 to succ(ymax) do for j:=0 to succ(xmax) do f0[j,i]:=4;
   for i:=2 to pred(ymax) do for j:=2 to pred(xmax) do f0[j,i]:=0;
   w[1].x0:=12;   
   w[2].x0:=24;
   for i:=1 to 2 do w[i].y0:=12;
   for i:=3 to xmax-3 do for j:=1 to 7 do
   if (i mod 3)=0 then f0[i,j*3+1]:=9 else f0[i,j*3+1]:=random(3)+6;
   for i:=3 to xmax-3 do for j:=1 to 7 do
   if (i mod 3)=0 then f0[i,j*3]:=13 else f0[i,j*3]:=4;
   for i:=2 to ymax-1 do f0[xmax-1,i]:=5;
   nh:=4;
   for i:=1 to nh do with h0[i] do begin
      id:=pred(i);
      nach:=i;
      case i of
      1: begin x:=2;      y:=2;      end;
      2: begin x:=xmax-1; y:=ymax-1; end;
      3: begin x:=2;      y:=ymax-1; end;
      4: begin x:=xmax-1; y:=2;      end;
      end;
      f0[x,y]:=10;
   end;

   flow:=0;
   for i:=1 to xmax do for j:=1 to ymax do
   if f0[i,j] in [6..8] then inc(flow);
   ue:='* I N T E R N *';

{ Leveldatei ffnen: }
{$i-}   
   str(level:3,temp);
   for i:=1 to 3 do if temp[i]=' ' then temp[i]:='0';
   temp:=levelfile+temp;
   assign(f,temp);
   reset(f);
   
{ einfllen: }
   if ioresult=0 then begin
   flow:=0;
   nh:=0;
   readln(f,ue);
   for i:=1 to ymax do begin
      readln(f,temp);
      for j:=1 to length(temp) do begin
         k:=pos(temp[j],code);
         case k of
         1: f0[j,i]:=0;
      2..3: begin
               w[pred(k)].x0:=j;
               w[pred(k)].y0:=i;
            end;
         4: f0[j,i]:=k;     { Mauer }
      5..8: begin           { Blumen }
               f0[j,i]:=k;
               if k>5 then inc(flow);
            end;
         9: f0[j,i]:=k;
    10..19: begin           { Loch }
               f0[j,i]:=10;
               inc(nh);
               with h0[nh] do begin
                  id:=k-10;
                  nach:=succ(id);
                  x:=j;
                  y:=i;
               end;
            end;
    20..22: f0[j,i]:=k-9;
         end;
      end;
   end;
   close(f);
   end else level:=0;
{$i+}

{ Hhlen schlieen und Startlcher freihalten: }
   for i:=1 to nh do if h0[i].id=pred(nh) then h0[i].nach:=0;
   for i:=1 to 2 do f0[w[i].x0,w[i].y0]:=0;
end;
{ -------------------------------------------------------------------- }
procedure initwurm(i:integer; var w:wuermer);
begin
with w[i] do begin
   headptr:=0;
   tailptr:=0;
   zustand:=1;
   counter:=0;
   ri:=3;
   x[headptr]:=x0;
   y[headptr]:=y0;
   DrawImage(x0*dx+ox,y0*dy+oy,addr(ima[5*i+ri+1]));
end;
end;

{ -------------------------------------------------------------------- }
procedure drawelement(x,y,k:integer);
begin
   case k of
      0,3: rectfill(x*dx+ox,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),14);
    1.. 2: drawimage(x*dx+ox,y*dy+oy,addr(ima[5*k]));  { Wuermer      }
    4..10: drawimage(x*dx+ox,y*dy+oy,addr(ima[12+k])); { Stein - Loch }
   11..12: drawimage(x*dx+ox,y*dy+oy,addr(ima[13+k])); { Eier, Bomben }
       13: drawimage(x*dx+ox,y*dy+oy,addr(ima[10+k])); { Kaktus       }
   end;
end;

procedure feldzeichnen(var f:feld);
var i,j,k:integer;
begin
   rectfill(ox,oy,ox+succ(xmax)*dx,oy+succ(ymax)*dy,14);
   for i:=1 to ymax do for j:=1 to xmax do drawelement(j,i,f[j,i]);
end;

{ --------------------------------------------------------------------- }

procedure hiscorescreen(typ:integer);
var i,j,k,x,y,z,c1,c2:integer;
begin
   case typ of
   0: begin c1:=15; c2:=25; end;
   1: begin c1:= 4; c2:= 9; end;
   2: begin c1:= 6; c2:=14; end;
   end;
   rectfill(ox-8,oy,ox+succ(xmax)*dx+8,oy+succ(ymax)*dy,14);
   for i:=1 to 800 do begin
      x:=random(xmax)+1;
      y:=random(ymax)+1;
      z:=random(15)+16;
      if z>25 then z:=c2;
      drawimage(x*dx+ox,y*dy+oy,addr(ima[z]));
   end;
   if typ=0 then showhighscore(hsc,16*dx+ox,8*dy+oy,dy,c1,1,0,2) else
   updathighscore(wurmno[typ].punkte,hscfil,hsc,16*dx+ox,8*dy+oy,dy,c1,1,0,2);
end;

{ ---------------------------------------------------------------------- }
procedure zeichnewurm(n:integer; wurmno:wurm);
var i,x,c:integer;
begin
   if n=1 then x:=ox1 else x:=ox2;
   if n=1 then c:=9   else c:=14;
   rectfill(x,oy0+dy0,x+dx,oy0+10*dy0,14);
   if wurmno.anz>0 then for i:=1 to wurmno.anz do
   DrawImage(x,oy+i*dy0+oy0,addr(ima[c]));
end;

procedure updatlevel(level:integer; lname:string);
var temp:string;
begin
   str(level:3,temp);
   temp:='Level'+temp+': '+lname;
   rectfill(168,460,467,469,15);
   setcolor(1); outtextxy(176,460,temp);
   setcolor(0); outtextxy(175,460,temp);
end;

procedure updatpunkte(i:integer; punkte:longint);
var x:integer;
    temp:string;
begin
str(punkte:7,temp);
if i=1 then x:=88 else x:=544;
rectfill(x,460,x+63,469,15);
setcolor(1); outtextxy(x+8,460,temp);
setcolor(0); outtextxy(x+7,460,temp);
end;

{ ---------------------------------------------------------------- }

procedure auswertung(dran:integer; var wurmno:wuermer; var f:feld);
var i,j,k,l,xx,yy,kennung:integer;

procedure neuepos;
begin
with wurmno[dran] do begin
   { Head wird Glied }
   if f0[x[headptr],y[headptr]]<>10 then f[x[headptr],y[headptr]]:=dran
                                    else f[x[headptr],y[headptr]]:=10;
   drawimage(x[headptr]*dx+ox,y[headptr]*dy+oy,addr(ima[5*dran+5]));

   { letztes Glied loeschen }
   if f0[x[tailptr],y[tailptr]]=10 then f[x[tailptr],y[tailptr]]:=10
                                   else f[x[tailptr],y[tailptr]]:=0;
   drawelement(x[tailptr],y[tailptr],f[x[tailptr],y[tailptr]]);
   tailptr:=succ(tailptr) mod wmax;

   { neuer Kopf }
   if f0[xx,yy]<>10 then f[xx,yy]:=dran else f[xx,yy]:=10;
   headptr:=succ(headptr) mod wmax;
   x[headptr]:=xx;
   y[headptr]:=yy;
   drawimage(xx*dx+ox,yy*dy+oy,addr(ima[succ(dran*5+ri)]));
end;
end;

{ --- }

begin
{ alte Position markieren }
with wurmno[dran] do begin
   xx:=x[headptr];
   yy:=y[headptr];
end;

{ neue Richtung erschnuppern: }
with wurmno[dran] do case ri of  
0: if xx>0 then xx:=pred(xx);
1: if yy>0 then yy:=pred(yy);
2: if xx<xmax then xx:=succ(xx);
3: if yy<ymax then yy:=succ(yy);
end;
kennung:=f[xx,yy];

{ Wurm bewegt sich: }
with wurmno[dran] do if (xx<>x[headptr]) or (yy<>y[headptr]) then begin
   case kennung of
   0  : neuepos; { Abmarsch ohne Zoegern }
   1,2: begin   {  Wurm tot }
           zustand:=3;
           if tailptr<=headptr then begin
              for i:=tailptr to headptr do begin
                if f0[x[i],y[i]]=10 then begin
                   f[x[i],y[i]]:=10;
                   drawelement(x[i],y[i],10);
                end else begin
                   f[x[i],y[i]]:=0;
                   drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                end;
              end;
           end else begin
              for i:=tailptr to pred(wmax) do begin
                 if f0[x[i],y[i]]=10 then begin
                    f[x[i],y[i]]:=10;
                    drawelement(x[i],y[i],10);
                 end else begin
                    f[x[i],y[i]]:=0;
                    drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                 end;
             end;
             for i:=0 to headptr do begin
                if f0[x[i],y[i]]=10 then begin
                    f[x[i],y[i]]:=10;
                    drawelement(x[i],y[i],10);
                 end else begin
                    f[x[i],y[i]]:=0;
                    drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                 end;
              end;
           end;
           dec(anz);
           zeichnewurm(dran,wurmno[dran]);
           delay(50);
           if anz>0 then initwurm(dran,wurmno)
        end;
    4: drawimage(x[headptr]*dx+ox,y[headptr]*dy+oy,addr(ima[succ(dran*5+ri)]));
    5: begin { Groesse zurueck auf 1 }
          if tailptr<=headptr then begin
             for i:=tailptr to headptr do begin
                if f0[x[i],y[i]]=10 then f[x[i],y[i]]:=10
                                    else f[x[i],y[i]]:=0;
                drawelement(x[i],y[i],f[x[i],y[i]]);
             end;
          end else begin
             for i:=tailptr to pred(wmax) do begin
                if f0[x[i],y[i]]=10 then f[x[i],y[i]]:=10
                                    else f[x[i],y[i]]:=0;
                drawelement(x[i],y[i],f[x[i],y[i]]);
             end;
             for i:=0 to headptr do begin
                if f0[x[i],y[i]]=10 then f[x[i],y[i]]:=10
                                    else f[x[i],y[i]]:=0;
                drawelement(x[i],y[i],f[x[i],y[i]]);
             end;
          end;
          tailptr:=headptr;
          delay(50);
          neuepos;
       end;
    6..8: begin { Wachstumspunkte }
             i:=x[tailptr];
             j:=y[tailptr];
             k:=kennung;
             case k of
             6: l:=1;
             7: l:=2;
             8: l:=5;
             end;
             for k:=1 to l do begin
                tailptr:=(tailptr+pred(wmax)) mod wmax;
                x[tailptr]:=i;
                y[tailptr]:=j;
                inc(punkte);
             end;
             neuepos;
             updatpunkte(dran,punkte);
             dec(nflowers);
          end;
    9: begin  { Gift }
          counter:=10;
          neuepos;
          drawimage(xx*dx+ox,yy*dy+oy,addr(ima[succ(ri)]));
       end;
    10: begin   { Loch }
           { Hoehlen-ID suchen: }
           k:=-1;
           for i:=1 to 10 do with hoehleno[i] do
           if (x=xx) and (y=yy) then k:=i;
           if k<0 then write(chr(7)) else k:=hoehleno[k].nach;
           for i:=1 to 10 do if hoehleno[i].id=k then begin
              xx:=hoehleno[i].x;
              yy:=hoehleno[i].y;
           end;
           neuepos;
        end;
    11: begin   { Eier }
          if anz<7 then inc(anz);
          neuepos;
          zeichnewurm(dran,wurmno[dran]);
        end;
    12: begin  { Boembskes  }
           neuepos;
           k:=succ(dran mod nplayer);
           if nplayer>1 then with wurmno[k] do begin
              zustand:=3;
              if tailptr<=headptr then begin
                 for i:=tailptr to headptr do begin
                   if f0[x[i],y[i]]=10 then begin
                      f[x[i],y[i]]:=10;
                      drawelement(x[i],y[i],10);
                   end else begin
                      f[x[i],y[i]]:=0;
                      drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                   end;
                 end;
              end else begin
                 for i:=tailptr to pred(wmax) do begin
                    if f0[x[i],y[i]]=10 then begin
                       f[x[i],y[i]]:=10;
                       drawelement(x[i],y[i],10);
                    end else begin
                       f[x[i],y[i]]:=0;
                       drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                    end;
                end;
                for i:=0 to headptr do begin
                   if f0[x[i],y[i]]=10 then begin
                       f[x[i],y[i]]:=10;
                       drawelement(x[i],y[i],10);
                    end else begin
                       f[x[i],y[i]]:=0;
                       drawimage(x[i]*dx+ox,y[i]*dy+oy,addr(ima[5]));
                    end;
                 end;
              end;
              dec(anz);
              zeichnewurm(k,wurmno[k]);
              delay(50);
              if anz>0 then initwurm(k,wurmno)
           end;
        end;
    13: begin  { Kaktus }
           neuepos;
           k:=succ(dran mod nplayer);
           if nplayer>1 then with wurmno[k] do begin
              counter:=10;
              drawimage(xx*dx+ox,yy*dy+oy,addr(ima[succ(ri)]));
           end;
        end;
    end;
end;
end;

{ ==================================================================== }
begin
for i:=1 to 2 do with wurmno[i] do begin
   anz:=0;
   punkte:=0;
end;
nplayer:=1;
modus:=1;

textmode(3);
textcolor(white);
writeln('_____________________________________________________________________________');
textbackground(blue);
writeln('                                                                             ');
textcolor(green);
writeln('   ooooooooooooooooooooo<                      >oooooooooooooooooooooooooo   ');
textcolor(yellow);
writeln('                          U J A s    W u r l i                               ');
textcolor(brown);
writeln('   ooooooooooooooooooooo<                      >oooooooooooooooooooooooooo   ');
textcolor(white);
writeln('_____________________________________________________________________________');
textbackground(black);
textcolor(lightgray);
writeln;
writeln(' --- einige Einstellungen zu Wurli (Voreinstellungen: 1) : ');
writeln('   - Spieler 1, gruener Wurm, laeuft mit Cursortasten    - ');
writeln('   - Spieler 2, brauner Wurm, laeuft mit Joystick    - ');

repeat
   writeln;
   write(' Wieviele Spieler? [1,2] '); readln(antwort);
   if length(antwort)=0 then nplayer:=1 else val(antwort,nplayer,i);
until nplayer in [1,2];

if nplayer=2 then begin
   joy.sensex:=5;
   joy.sensey:=5;
   joyistda:=joyda;
   if joyistda then joycalib(joy) else begin
      writeln('Sorry, kein Joystick gefunden');
      writeln('Kannst aber auch Tasten nehmen:');
      writeln(' oben:w, unten:y/z, rechts:s, links:a');
      ch:=readkey;
   end;
end;


time1:=3;

bildschirm(ok);
loadhighscore(hscfil,hsc);
if ok then holeimages(ok);

if ok then begin
   ende:=false;

   zeichnescreen;
   hiscorescreen(0);
   ch:=readkey;
   for i:=1 to nplayer do with wurmno[i] do begin
      anz:=5;
      punkte:=0;
   end;

   level:=1;
   while not ende do begin
      readlevel(level,ue,nflowers,f0,hoehleno,wurmno);
      f:=f0;
      feldzeichnen(f);
      updatlevel(level,ue);
      for i:=1 to nplayer do begin
         updatpunkte(i,wurmno[i].punkte);
         if wurmno[i].anz>0 then initwurm(i,wurmno);
         zeichnewurm(i,wurmno[i]);
      end;
      ch:='.';

      repeat
         for i:=1 to 20 do begin
            delay(time1);
            if (nplayer=2) and joyistda then with joy do begin
               joylesen(joy);
               if x<-2 then wurmno[2].ri:=0;
               if x>+2 then wurmno[2].ri:=2;
               if y<-2 then wurmno[2].ri:=1;
               if y>+2 then wurmno[2].ri:=3;
               if wurmno[2].oldri<>wurmno[2].ri then with wurmno[2] do begin
                  oldri:=ri;
                  putimage(x[headptr]*dx+ox,y[headptr]*dy+oy,ima[succ(2*5+ri)].p_data^,normalput);
               end;
            end else delay(time1*5);

            while keypressed do begin
               ch:=readkey;
               case ord(upcase(ch)) of
               72: wurmno[1].ri:=1;   { up    }
               75: wurmno[1].ri:=0;   { left  }
               77: wurmno[1].ri:=2;   { right }
               80: wurmno[1].ri:=3;   { down  }
               65: wurmno[2].ri:=0;
               83: wurmno[2].ri:=2;
               87: wurmno[2].ri:=1;
               88,90: wurmno[2].ri:=3;
               27    : ende:=true;
               43    : begin nflowers:=0; end;  { + }
               45    : begin level:=level-2; nflowers:=0; end;  { - }
               end;
               for j:=1 to nplayer do with wurmno[j] do
               putimage(x[headptr]*dx+ox,y[headptr]*dy+oy,ima[succ(j*5+ri)].p_data^,normalput);
            end;
         end;

         { Wrmer tanzen lassen: }
         if not ende then begin
            for i:=1 to nplayer do with wurmno[i] do
            if anz>0 then
            if counter>0 then dec(counter) else auswertung(i,wurmno,f);
         end; 

         if (wurmno[1].anz<1) and (wurmno[2].anz<1) then begin
            ende:=true;
            hiscorescreen(1);
            if nplayer=2 then hiscorescreen(2);
            ch:=readkey;
         end;

      until ende or (nflowers=0);
      if nflowers=0 then begin
       {  fanfare; }
         inc(level);
      end;
   end;
   textmode(3);
end;
end.
