program Wurlied;
{ UJA 28.10.95: Wurli-Leveleditor }
{     29.10.95: Level laden, Darstellung, Gadgets, Feld, Level speichern  }


uses crt,graph,dos,drivers,intuit;

const
   xmax=36;   ymax=24;    dx=16;   dy=16;   ox=16;     oy=24;
   ox1=  8;   ox2 =616;   oy0=24;  dy0=24;  nwuermer=2;
   imafil='Wurli.ima'; levelfile='WurliL.';
   titel ='o< *  U J A s   W u r l i  -  Leveleditor *  Vers.0.900 10/95  *  TP6  *  >o';

type
   feld=array[0..succ(xmax),0..succ(ymax)] of integer;
   liste=array[0..9,0..1] of integer;
var
   ima               :array[1..25] of Image;
   igad              :array[1..30] of Gadget;
   itext1,itext2     :array[1..18] of Intuitext;
   textinfo          :array[1.. 2] of Strinfo;
   ibord1,ibord2     :array[1.. 4] of Border;
   xy1,xy2           :array[1.. 4] of Koords;

   ok,ende,neu              :boolean;
   ch                       :char;
   f0,f                     :feld;
   lname                    :string;
   level,i,j,k,mx,my,select :integer;
   w,h,w0,h0                :liste;

{ ---------------------------------------------------------------------- }
procedure bildschirm(var ok:boolean);
const pal:array[0..15,0..2] of integer=
          (( 0, 0, 0),(63,60,53),( 0,38,38),(39,55,55),
           (13,45,42),(43,21,13),(50,37,26),(57,51,35),
           (63, 0, 0),(63,53, 0),( 5,48, 0),(20, 5,55),
           (39, 0, 0),(47,35, 0),(15,28,23),(26,34,37));
var i,j:integer;

begin
initscreen(ok);
if ok then begin
   for i:=0 to 15 do begin
      setpalette(i,i);
      setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   end;
end;
end;

procedure zeichnescreen;
var i,j,k,x,y:integer;
    temp     :string;
begin
   rectfill(0,0,639,479,14);
   setcolor(3); line(1,478,1,1);       line(1,1,638,1);
   setcolor(2); line(638,2,638,478);   line(1,478,638,478);
   rectfill(8,8,631,23,15);
   setcolor(1); line(8,23,8,8);        line(8,8,631,8);
   setcolor(0); line(631,9,631,23);    line(8,23,631,23);
   rectfill(8,456,631,471,15);
   setcolor(1); line(8,471,8,456);     line(8,456,631,456);
   setcolor(0); line(631,457,631,471); line(8,471,631,471);
   setcolor(1); outtextxy(16,12,titel);
   setcolor(0); outtextxy(15,12,titel);
end;

procedure holeimages(var ok:boolean);
var i:integer;
    f:file;
    size,anz:word;
begin
{$i-}
assign(f,imafil);
reset(f,1);
ok:=ioresult=0;
{$i+}
if ok then begin
   for i:=1 to 25 do begin
      blockread(f,ima[i],sizeof(image),anz);
      with ima[i] do begin
         size:=imagesize(1,1,width,height);
         getmem(p_data,size);
         blockread(f,p_data^,size,anz);
      end;
   end;
   close(f);
end;
end;



procedure initstructures;
var xy:koords;
     i:integer;
begin
itext1[1].itext:='New ';
itext1[2].itext:='Load';
itext1[3].itext:='Save';
itext1[4].itext:='Quit';
itext1[5].itext:='Level:';
itext1[6].itext:='LName:';
for i:=7 to 16 do itext1[i].itext:=chr(41+i);

for i:=1 to 16 do with itext1[i] do begin
   x:=4;
   y:=4;
   fpen:=1;
   bpen:=14;
   drmode:=jam1;
   p_nexttext:=addr(itext2[i])
end;
for i:=5 to 6 do itext1[i].x:=-48;
itext2:=itext1;
for i:=1 to 16 do with itext2[i] do begin
   x:=itext1[i].x-1;
   fpen:=0;
   p_nexttext:=nil
end;

for i:=7 to 16 do begin
   itext1[i].fpen:=5;
   itext2[i].fpen:=1;
end;

for i:=1 to 2 do with textinfo[i] do begin
   x:=4; y:=4;
   if i=1 then maxlen:=3 else maxlen:=15;
   fpen:=0; bpen:=4;
   if i=1 then buff:='000' else buff:='- Intern -';
   ubuff:='';
end;


xy[0]:=0; xy[1]:=pred(dy); xy[2]:=0; xy[3]:=0; xy[4]:=pred(dx); xy[5]:=0;
xy1[1]:=xy;
xy[0]:=0; xy[1]:=pred(dy); xy[2]:=pred(dx); xy[3]:=pred(dy);
xy[4]:=pred(dx); xy[5]:=1;
xy2[1]:=xy;

xy[0]:=0; xy[1]:=pred(dy); xy[2]:=0; xy[3]:=0; xy[4]:=pred(40); xy[5]:=0;
xy1[2]:=xy;
xy[0]:=0; xy[1]:=pred(dy); xy[2]:=pred(40); xy[3]:=pred(dy);
xy[4]:=pred(40); xy[5]:=1;
xy2[2]:=xy;

xy[0]:=-1; xy[1]:=dy; xy[2]:=-1; xy[3]:=-1; xy[4]:=40; xy[5]:=-1;
xy1[3]:=xy;
xy[0]:=-1; xy[1]:=dy; xy[2]:=40; xy[3]:=dy;
xy[4]:=40; xy[5]:=0;
xy2[3]:=xy;

xy[0]:=-1; xy[1]:=dy; xy[2]:=-1; xy[3]:=-1; xy[4]:=128; xy[5]:=-1;
xy1[4]:=xy;
xy[0]:=-1; xy[1]:=dy; xy[2]:=128; xy[3]:=dy;
xy[4]:=128; xy[5]:=0;
xy2[4]:=xy;

for i:=1 to 4 do begin
   with ibord1[i] do begin
      x:=0;
      y:=0;
      fpen:=1;
      bpen:=15;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy1[i]);
      p_nextborder:=addr(ibord2[i]);
   end;
   with ibord2[i] do begin
      x:=0;
      y:=0;
      fpen:=0;
      bpen:=15;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy2[i]);
      p_nextborder:=nil;
   end;
end;

for i:=1 to 4 do with igad[i] do begin
   id:=i;
   x:=432+40*i;
   y:=(ymax+3)*dy+oy;
   width:=40;
   height:=dy;
   bpen:=15;
   hibpen:=bpen;
   p_loborder:=addr(ibord1[2]);
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=nil;
   p_lointuitext:=addr(itext1[i]);
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;

for i:=5 to 6 do with igad[i] do begin
   id:=i;
   if i=5 then x:=60 else x:=160;
   y:=(ymax+3)*dy+oy;
   if i=5 then width:=40 else width:=128;
   height:=dy;
   bpen:=15;
   hibpen:=bpen;
   p_loborder:=addr(ibord1[i-2]);
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=nil;
   p_lointuitext:=addr(itext1[i]);
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=strgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=addr(textinfo[i-4]);
   p_nextgadget:=addr(igad[succ(i)]);
end;


for i:=7 to 15 do with igad[i] do begin
   id:=i;
   x:=ox+(i+7)*dx;
   y:=(ymax+2)*dy+oy;
   width:=dx;
   height:=dy;
   if i>7 then bpen:=-1 else bpen:=14;
   hibpen:=bpen;
   p_loborder:=addr(ibord1[1]);
   p_hiborder:=p_loborder;
   if i>7 then p_loimage:=addr(ima[6+i]) else p_loimage:=nil;
   if i=8 then p_loimage:=addr(ima[10]);
   p_hiimage:=p_loimage;
   p_lointuitext:=nil;
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;

for i:=16 to 25 do with igad[i] do begin
   id:=i;
   x:=ox+(i+7)*dx;
   y:=(ymax+2)*dy+oy;
   width:=dx;
   height:=dy;
   bpen:=-1;
   hibpen:=bpen;
   p_loborder:=addr(ibord1[1]);
   p_hiborder:=p_loborder;
   p_loimage:=addr(ima[22]);
   p_hiimage:=p_loimage;
   p_lointuitext:=addr(itext1[i-9]);
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;

for i:=26 to 28 do with igad[i] do begin
   id:=i;
   x:=ox+(i+7)*dx;
   y:=(ymax+2)*dy+oy;
   width:=dx;
   height:=dy;
   bpen:=-1;
   hibpen:=bpen;
   p_loborder:=addr(ibord1[1]);
   p_hiborder:=p_loborder;
   p_loimage:=addr(ima[i-3]);
   p_hiimage:=p_loimage;
   p_lointuitext:=nil;
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=addr(igad[succ(i)]);
end;

i:=29;
with igad[i] do begin
   id:=i;
   x:=dx+ox;
   y:=dy+oy;
   width:=xmax*dx;
   height:=ymax*dy;
   bpen:=-1;
   hibpen:=bpen;
   p_loborder:=nil;
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=nil;
   p_lointuitext:=nil;
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   p_nextgadget:=nil;
end;
end;



{ ----- wurli1.inc - Feld einlesen ----- }

procedure readlevel(var level:integer; var ue:string;
                    var f0:feld; var w,h:liste);
const code=' Ww#oO*x+0123456789KEB';
var i,j,k,nh:integer;
    temp    :string;
    f       :text;
    ok      :boolean;

begin
   for i:=0 to 9 do begin
      w[i,0]:=0;
      h[i,0]:=0;
      w[i,1]:=0;
      h[i,1]:=0;
   end;

{ Leveldatei ffnen: }
{$i-}   
   str(level:3,temp);
   for i:=1 to 3 do if temp[i]=' ' then temp[i]:='0';
   temp:=levelfile+temp;
   assign(f,temp);
   reset(f);
   
{ einfllen: }
   if ioresult=0 then begin
   readln(f,ue);
   for i:=1 to ymax do begin
      readln(f,temp);
      for j:=1 to length(temp) do begin
         k:=pred(pos(temp[j],code));
         f0[j,i]:=k;
         if k in [1..2] then begin
            inc(w[0,0]);
            w[k,0]:=j;
            w[k,1]:=i;
         end;
         if k in [9..18] then begin
            inc(nh);
            h[k-9,0]:=j;
            h[k-9,1]:=i;
         end;
      end;
   end;
   close(f);
   end else begin
      level:=0;
      ue:='- Neues Level -';
      for i:=1 to xmax do for j:=1 to ymax do f0[i,j]:=0;
      for i:=1 to xmax do begin
         f0[i,1]:=3;
         f0[i,ymax]:=3;
      end;
      for i:=2 to pred(ymax) do begin
         f0[1,i]:=3;
         f0[xmax,i]:=3;
      end;
   end;
{$i+}

end;
{ -------------------------------------------------------------------- }
procedure savelevel(var level:integer; var ue:string; var f0:feld;
                   var h,w:liste);
const code:string=' Ww#oO*x+0123456789KEB';
var i,j,k,nh:integer;
    temp    :string;
    f       :text;
    ok      :boolean;
    h2      :liste;

begin
{ Check, ob beide Wurlis initialisiert sind: }
ok:=(w[1,0]>0) and (w[2,0]>0);
if not ok then write(chr(7)) else begin

   { Hoehlen dichtpacken: }
   j:=0;
   for i:=0 to 9 do begin h2[i,0]:=0; h2[i,1]:=0; end;
   for i:=0 to 9 do begin
      if (h[i,0]>0) and (h[i,0]<=xmax) then begin
         h2[j,0]:=h[i,0];
         h2[j,1]:=h[i,1];
         inc(j);
      end;
   end;
   for i:=0 to 9 do if h2[i,0]>0 then f0[h2[i,0],h2[i,1]]:=i+9;

   { Leveldatei ffnen: }
   str(level:3,temp);
   for i:=1 to 3 do if temp[i]=' ' then temp[i]:='0';
   temp:=levelfile+temp;
   assign(f,temp);
   rewrite(f);

{ einfllen: }
   writeln(f,ue);
   for i:=1 to ymax do begin
      temp:='';
      for j:=1 to xmax do temp:=temp+code[succ(f0[j,i])];
      writeln(f,temp);
   end;
   close(f);

end;
end;

{ -------------------------------------------------------------------- }
procedure drawelement(x,y,k:integer);
{ k laeuft von 0 bis 22 }
var i   :integer;
    temp:string;
begin
   case k of
   0: rectfill(x*dx+ox,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),14);
   1..2: drawimage(x*dx+ox,y*dy+oy,addr(ima[5*k+5])); { Wuermer         }
   3..8: drawimage(x*dx+ox,y*dy+oy,addr(ima[13+k]));  { Stein - Flasche }
   9..18: begin                                       { Hoehlen         }
              drawimage(x*dx+ox,y*dy+oy,addr(ima[22]));
              str(k-9:1,temp);
              setcolor(1);
              outtextxy(x*dx+ox+4,y*dy+oy+4,temp);
           end;
   19..22: drawimage(x*dx+ox,y*dy+oy,addr(ima[4+k])); { Kaktus - Bomben }
   end;
   DrawBorder(x*dx+ox,y*dy+oy,addr(ibord1[1]));
end;

procedure feldzeichnen(var f:feld);
var i,j,k:integer;
begin
   rectfill(ox,oy,ox+succ(xmax)*dx,oy+succ(ymax)*dy,14);
   for i:=1 to ymax do for j:=1 to xmax do drawelement(j,i,f[j,i]);
end;

{ --------------------------------------------------------------------- }
procedure rahmen(x,y:integer);
var i,j,k,l:integer;
begin
   i:=x*dx+ox;
   j:=y*dy+oy;
   drawborder(i,j,addr(ibord1[1]));
end;

procedure pfeil(n:integer);
var i,j:integer;
begin
rectfill(dx+ox,(ymax+1)*dy+oy,xmax*dx+ox+pred(dx),(ymax+1)*dy+oy+14,14);
i:=14+n;
rectfill(i*dx+ox+4,(ymax+1)*dy+oy,i*dx+ox+12,(ymax+1)*dy+oy+14,0);
rectfill(i*dx+ox+5,(ymax+1)*dy+oy+1,i*dx+ox+10,(ymax+1)*dy+oy+13,1);
end;


begin

bildschirm(ok);
if ok then holeimages(ok);

if ok then begin
   ende:=false;
   initstructures;
   zeichnescreen;
   level:=0;
   readlevel(level,lname,f0,w0,h0);
   f:=f0; w:=w0; h:=h0;
   feldzeichnen(f);
   initmouse;
   select:=0;
   pfeil(select);
   refreshgadgets(addr(igad[1]));

   while not ende do begin
      gadgetup(addr(igad[1]),i,mx,my);

      case i of
      1: begin
            f:=f0; w:=w0; h:=h0;
            feldzeichnen(f);
         end;
      2: begin
            readlevel(level,lname,f0,w0,h0);
            igad[6].p_specialinfo^.buff:=lname;
            drawgadget(addr(igad[6]));
            f:=f0; w:=w0; h:=h0;
            feldzeichnen(f);
         end;
      3: begin  { speichern }
            savelevel(level,lname,f,h,w);
            feldzeichnen(f);
         end;
      4: ende:=true;
      5: begin { Levelnummer holen }
            getstring(igad[i]);
            val(igad[i].p_specialinfo^.buff,j,k);
            if k=0 then level:=j;
            drawgadget(addr(igad[i]));
         end;
      6: begin { Levelnamen holen }
            getstring(igad[i]);
            lname:=igad[i].p_specialinfo^.buff;
            drawgadget(addr(igad[i]));
         end;
      7..28: begin
                select:=i-7;
                pfeil(select);
             end;
      29: begin { setzen }
             { Koordinaten: }
             j:=(mx-ox) div dx;
             k:=(my-oy) div dy;
             { alte Hoehlen und Wuermer loeschen: }
             if f[j,k] in [1..2] then w[f[j,k],0]:=0;
             if f[j,k] in [9..18] then h[f[j,k]-9,0]:=0;

             { Wuermer updaten: }
             if select in [1..2] then begin
                if w[select,0]>0 then begin
                   f[w[select,0],w[select,1]]:=0;
                   drawelement(w[select,0],w[select,1],0);
                end;
                w[select,0]:=j;
                w[select,1]:=k;
             end;
             { Hoehlen updaten: }
             if select in [9..18] then begin
                if h[select-9,0]>0 then begin
                   f[h[select-9,0],h[select-9,1]]:=0;
                   drawelement(h[select-9,0],h[select-9,1],0);
                end;
                h[select-9,0]:=j;
                h[select-9,1]:=k;
             end;
             f[j,k]:=select;
             drawelement(j,k,f[j,k]);
          end;
      end;
   end; { ende }
end;

textmode(3);
end.
